#ifndef GRADE
    #define GRADE
    
#ifndef SOUNDS
    #define SOUNDS
    #include "sounds.h"
#endif
#include "autonomos.h"
#include "colisao.h"
//#include "sounds.h"


class BaseGrade{
public:
    int pontAut;
    bool princIsHere;

    Bala* balasAmigo[15];
    int pontBA;
    int quantBA;

    Bala* balasInimigo[30];
    int pontIni;
    int quantIni;

    Autonomos* autonomos[40];
    int quantAut;

    BaseGrade(){
        this->princIsHere = false;

        this->pontBA = 0;
        this->quantBA = 0;

        this->pontIni = 0;
        this->quantIni = 0;

        this->pontAut = 0;
        this->quantAut = 0;
        }
    ~BaseGrade(){
        this->esvaziarBA();
        this->esvaziarBalIni();
        this->esvaziarAut();
        free(this->balasAmigo);
        free(this->balasInimigo);
        free(this->autonomos);
    }
    void inserirBalaAmigo(Bala* bala){
        if(quantBA<15)
            this->balasAmigo[quantBA++] = bala;
        else
            delete(bala);
    }
    void inserirBalaInimigo(Bala* bala){
        if(quantIni<30)
            this->balasInimigo[quantIni++] = bala;
        else
            delete(bala);
    }
    void inserirAutonomo(Autonomos* autonomo){
        if(quantAut<40)
            this->autonomos[quantAut++] = autonomo;
        else
            delete(autonomo);
    }
    void resetBA(){
        this->pontBA = 0;        
    }
    void resetIni(){
        this->pontIni = 0;        
    }
    void resetAut(){
        this->pontAut = 0;
    }
    Bala* pegarProxBA(){
        if((this->pontBA < this->quantBA) && (this->quantBA > 0)){
            return this->balasAmigo[this->pontBA++];
        }else
            return NULL;
    }
    Bala* pegarProxBalIni(){
        if((this->pontIni < this->quantIni) && (this->quantIni > 0)){
            return this->balasInimigo[this->pontIni++];
        }else
            return NULL;
    }
    Autonomos* pegarProxAut(){
        if((this->pontAut < this->quantAut) && (this->quantAut > 0)){
            return this->autonomos[this->pontAut++];
        }else
            return NULL;
    }
    void removeEstaBA(){
        if(this->pontBA>0)
            this->balasAmigo[--this->pontBA] = this->balasAmigo[--this->quantBA];
    }
    void removeEstaBalIni(){
        if(this->pontIni>0)
            this->balasInimigo[--this->pontIni] = this->balasInimigo[--this->quantIni];
    }
    void removeEsteAut(){
        if(this->pontAut>0)
            this->autonomos[--this->pontAut] = this->autonomos[--this->quantAut];
    }
    void esvaziarBA(){
        while(this->quantBA > 0)
             delete(this->balasAmigo[--this->quantBA]);
    }
    void esvaziarBalIni(){
        while(this->quantIni > 0)
             delete(this->balasInimigo[--this->quantIni]);
    }
    void esvaziarAut(){
        while(this->quantAut > 0)
             delete(this->autonomos[--this->quantAut]);
    }
};

class Grade{
public:
    SAMPLE *som_tiro_inimigo;
    SAMPLE *escudo;
    SAMPLE *som_granada;
    BaseGrade* grade;
    int larguraGrade;
    int quantGrades;
    Cenario* cenario;
    int marcador;
	int i;
    
    InimigosStagio inimigosStagio;
    
    Grade(Cenario* cenario, int larguraGrade){
		this->i = 0;
        this->som_tiro_inimigo = load_sample(tiro_inimigo);
        this->escudo = load_sample(tiro_escudo);
        this->som_granada = load_sample(granada);
        this->grade = new BaseGrade[(this->quantGrades = (cenario->cenario_frente->w)/larguraGrade)+2]();
        this->larguraGrade = larguraGrade;
        this->cenario = cenario;
        this->marcador = 0;
        //OORGANIZACAO E INCERSSO
        this->inserirAutonomo((Autonomos*)this->inimigosStagio.refemCaminhando);
        this->inserirAutonomo((Autonomos*)this->inimigosStagio.caminhaoBand);
        this->inserirAutonomo((Autonomos*)this->inimigosStagio.inimigo1);
        this->inserirAutonomo((Autonomos*)this->inimigosStagio.inimigo2);
        this->inserirAutonomo((Autonomos*)this->inimigosStagio.inimigo3);
        this->inserirAutonomo((Autonomos*)this->inimigosStagio.inimigo4);
        this->inserirAutonomo((Autonomos*)this->inimigosStagio.inimigo5);
        this->inserirAutonomo((Autonomos*)this->inimigosStagio.inimigo6);
        this->inserirAutonomo((Autonomos*)this->inimigosStagio.inimigo7);
      //  this->inserirAutonomo((Autonomos*)this->inimigosStagio.inimigo8);
        this->inserirAutonomo((Autonomos*)this->inimigosStagio.inimigo9);
       // this->inserirAutonomo((Autonomos*)this->inimigosStagio.inimigo10);
        this->inserirAutonomo((Autonomos*)this->inimigosStagio.inimigoEscudo1);
        this->inserirAutonomo((Autonomos*)this->inimigosStagio.inimigoEscudo2);
        this->inserirAutonomo((Autonomos*)this->inimigosStagio.inimigoEscudo3);
        this->inserirAutonomo((Autonomos*)this->inimigosStagio.inimigoEscudo4);
        this->inserirAutonomo((Autonomos*)this->inimigosStagio.inimigoEscudo5);
        this->inserirAutonomo((Autonomos*)this->inimigosStagio.inimigoEscudo6);
        this->inserirAutonomo((Autonomos*)this->inimigosStagio.inimigoEscudo7);
       // this->inserirAutonomo((Autonomos*)this->inimigosStagio.inimigoEscudo8);
        this->inserirAutonomo((Autonomos*)this->inimigosStagio.inimigoEscudo9);
      //  this->inserirAutonomo((Autonomos*)this->inimigosStagio.inimigoEscudo10);
        this->inserirAutonomo((Autonomos*)this->inimigosStagio.passaro1);
        this->inserirAutonomo((Autonomos*)this->inimigosStagio.passaro2);
        this->inserirAutonomo((Autonomos*)this->inimigosStagio.passaro3);
        this->inserirAutonomo((Autonomos*)this->inimigosStagio.passaro4);
        this->inserirAutonomo((Autonomos*)this->inimigosStagio.placa_saida);        
    }
    ~Grade(){
        delete(this->grade);               
    }
    void inserirBA(Bala* bala){//LEMBRAR DE COLOCAR AS EXCESSOES DE INVASAO DE POSICAO INVALIDA
       if((bala->posicaoX/larguraGrade)<this->quantGrades)
           this->grade[bala->posicaoX/larguraGrade].inserirBalaAmigo(bala);
       else
           delete(bala);
    }
    void inserirBalIni(Bala* bala){
       if((bala->posicaoX/larguraGrade)<this->quantGrades)
           this->grade[bala->posicaoX/larguraGrade].inserirBalaInimigo(bala);
       else
           delete(bala);
    }
    void inserirAutonomo(Autonomos* autonomo){
       if((autonomo->posicaoX/larguraGrade)<this->quantGrades)
           this->grade[autonomo->posicaoX/larguraGrade].inserirAutonomo(autonomo);
       else
           delete(autonomo);
    }
    bool foiAlvejado(Autonomos* autonomo,bool direita, int posGrade){        
        Bala *bala;
        this->grade[posGrade].resetBA();
        this->grade[posGrade-1].resetBA();
        this->grade[posGrade+1].resetBA();
        
        while((bala = this->grade[posGrade].pegarProxBA()) != NULL){
            if(pontoRetangulo(bala->getPosAtqX()-4,bala->getPosAtqY(),autonomo->animacaoAtiva,autonomo->posicaoX,autonomo->posicaoY,direita) ||
               pontoRetangulo(bala->getPosAtqX()+4,bala->getPosAtqY(),autonomo->animacaoAtiva,autonomo->posicaoX,autonomo->posicaoY,direita) ||
               pontoRetangulo(bala->getPosAtqX(),bala->getPosAtqY()-3,autonomo->animacaoAtiva,autonomo->posicaoX,autonomo->posicaoY,direita) ||
               pontoRetangulo(bala->getPosAtqX(),bala->getPosAtqY()+2,autonomo->animacaoAtiva,autonomo->posicaoX,autonomo->posicaoY,direita)){
                this->inserirAutonomo((Autonomos*)new ColisaoBA(bala->posicaoX,bala->posicaoY,bala->colisBA));
                this->grade[posGrade].removeEstaBA();
                delete(bala);
                return true;
            }
        }
        while(posGrade>0 && (bala = this->grade[posGrade-1].pegarProxBA()) != NULL){
            if(pontoRetangulo(bala->getPosAtqX()-4,bala->getPosAtqY(),autonomo->animacaoAtiva,autonomo->posicaoX,autonomo->posicaoY,direita) ||
               pontoRetangulo(bala->getPosAtqX()+4,bala->getPosAtqY(),autonomo->animacaoAtiva,autonomo->posicaoX,autonomo->posicaoY,direita) ||
               pontoRetangulo(bala->getPosAtqX(),bala->getPosAtqY()-3,autonomo->animacaoAtiva,autonomo->posicaoX,autonomo->posicaoY,direita) ||
               pontoRetangulo(bala->getPosAtqX(),bala->getPosAtqY()+2,autonomo->animacaoAtiva,autonomo->posicaoX,autonomo->posicaoY,direita)){
                this->inserirAutonomo((Autonomos*)new ColisaoBA(bala->posicaoX,bala->posicaoY,bala->colisBA));                   
                this->grade[posGrade-1].removeEstaBA();
                delete(bala);
                return true;
            }
        }
        while(posGrade<this->quantGrades &&
             (bala = this->grade[posGrade+1].pegarProxBA()) != NULL){
            if(pontoRetangulo(bala->getPosAtqX()-4,bala->getPosAtqY(),autonomo->animacaoAtiva,autonomo->posicaoX,autonomo->posicaoY,direita) ||
               pontoRetangulo(bala->getPosAtqX()+4,bala->getPosAtqY(),autonomo->animacaoAtiva,autonomo->posicaoX,autonomo->posicaoY,direita) ||
               pontoRetangulo(bala->getPosAtqX(),bala->getPosAtqY()-3,autonomo->animacaoAtiva,autonomo->posicaoX,autonomo->posicaoY,direita) ||
               pontoRetangulo(bala->getPosAtqX(),bala->getPosAtqY()+2,autonomo->animacaoAtiva,autonomo->posicaoX,autonomo->posicaoY,direita)){
                this->inserirAutonomo((Autonomos*)new ColisaoBA(bala->posicaoX,bala->posicaoY,bala->colisBA));                   
                this->grade[posGrade+1].removeEstaBA();
                delete(bala);
                return true;
            }
        }
        return false;
    }
    bool colisRetanObjeto(Autonomos* autonomo,int largura,int altura, int posGrade){        
        Autonomos* aut;
        this->grade[posGrade].resetAut();
        this->grade[posGrade-1].resetAut();
        this->grade[posGrade+1].resetAut();
        
        while((aut = this->grade[posGrade].pegarProxAut()) != NULL){
            if((aut->tipo == INIMIGO_ATIRADOR || aut->tipo == INIMIGO_ESCUDO)&&(
               pontoRetangulo(autonomo->posicaoX,autonomo->posicaoY,aut->animacaoAtiva,aut->posicaoX,aut->posicaoY,(aut->tipo==INIMIGO_ATIRADOR?((InimigoAtirador*)aut)->direita:((InimigoEscudo*)aut)->direita)) ||
               pontoRetangulo(autonomo->posicaoX+largura,autonomo->posicaoY,aut->animacaoAtiva,aut->posicaoX,aut->posicaoY,(aut->tipo==INIMIGO_ATIRADOR?((InimigoAtirador*)aut)->direita:((InimigoEscudo*)aut)->direita)) ||
               pontoRetangulo(autonomo->posicaoX,autonomo->posicaoY+altura,aut->animacaoAtiva,aut->posicaoX,aut->posicaoY,(aut->tipo==INIMIGO_ATIRADOR?((InimigoAtirador*)aut)->direita:((InimigoEscudo*)aut)->direita)) ||
               pontoRetangulo(autonomo->posicaoX+largura,autonomo->posicaoY+altura,aut->animacaoAtiva,aut->posicaoX,aut->posicaoY,(aut->tipo==INIMIGO_ATIRADOR?((InimigoAtirador*)aut)->direita:((InimigoEscudo*)aut)->direita)))){
                 this->inserirAutonomo((Autonomos*)new ColisaoBomba(autonomo->posicaoX,autonomo->posicaoY,((BombaPrincipal*)autonomo)->colisBomba));
                 switch(aut->tipo){
                     case INIMIGO_ATIRADOR:
                         delete(((InimigoAtirador*)aut)->morrendo);
                         ((InimigoAtirador*)aut)->morrendo = new AnimacaoRotina(35,1,inimigosStagio.incinerado,0,-22);
                         ((InimigoAtirador*)aut)->morreu = true;
                         break;
                     case INIMIGO_ESCUDO:
                         delete(((InimigoEscudo*)aut)->morrendo);
                         ((InimigoEscudo*)aut)->morrendo = new AnimacaoRotina(35,1,inimigosStagio.incinerado,0,-20);
                         ((InimigoEscudo*)aut)->morreu = true;
                         ((InimigoEscudo*)aut)->estado = escudo_morto;
                         break;
                 }
                 return true;                 
            }
        }
        while((aut = this->grade[posGrade-1].pegarProxAut()) != NULL){
            if((aut->tipo == INIMIGO_ATIRADOR || aut->tipo == INIMIGO_ESCUDO)&&(
               pontoRetangulo(autonomo->posicaoX,autonomo->posicaoY,aut->animacaoAtiva,aut->posicaoX,aut->posicaoY,(aut->tipo==INIMIGO_ATIRADOR?((InimigoAtirador*)aut)->direita:((InimigoEscudo*)aut)->direita)) ||
               pontoRetangulo(autonomo->posicaoX+largura,autonomo->posicaoY,aut->animacaoAtiva,aut->posicaoX,aut->posicaoY,(aut->tipo==INIMIGO_ATIRADOR?((InimigoAtirador*)aut)->direita:((InimigoEscudo*)aut)->direita)) ||
               pontoRetangulo(autonomo->posicaoX,autonomo->posicaoY+altura,aut->animacaoAtiva,aut->posicaoX,aut->posicaoY,(aut->tipo==INIMIGO_ATIRADOR?((InimigoAtirador*)aut)->direita:((InimigoEscudo*)aut)->direita)) ||
               pontoRetangulo(autonomo->posicaoX+largura,autonomo->posicaoY+altura,aut->animacaoAtiva,aut->posicaoX,aut->posicaoY,(aut->tipo==INIMIGO_ATIRADOR?((InimigoAtirador*)aut)->direita:((InimigoEscudo*)aut)->direita)))){
                 this->inserirAutonomo((Autonomos*)new ColisaoBomba(autonomo->posicaoX,autonomo->posicaoY,((BombaPrincipal*)autonomo)->colisBomba));
                 switch(aut->tipo){
                     case INIMIGO_ATIRADOR:
                         delete(((InimigoAtirador*)aut)->morrendo);
                         ((InimigoAtirador*)aut)->morrendo = new AnimacaoRotina(35,1,inimigosStagio.incinerado,0,-22);
                         ((InimigoAtirador*)aut)->morreu = true;
                         break;
                     case INIMIGO_ESCUDO:
                         delete(((InimigoEscudo*)aut)->morrendo);
                         ((InimigoEscudo*)aut)->morrendo = new AnimacaoRotina(35,1,inimigosStagio.incinerado,0,-20);
                         ((InimigoEscudo*)aut)->morreu = true;
                         ((InimigoEscudo*)aut)->estado = escudo_morto;
                         break;
                 }
                 return true;
            }
        }
        while((aut = this->grade[posGrade+1].pegarProxAut()) != NULL){
            if((aut->tipo == INIMIGO_ATIRADOR || aut->tipo == INIMIGO_ESCUDO)&&(
               pontoRetangulo(autonomo->posicaoX,autonomo->posicaoY,aut->animacaoAtiva,aut->posicaoX,aut->posicaoY,(aut->tipo==INIMIGO_ATIRADOR?((InimigoAtirador*)aut)->direita:((InimigoEscudo*)aut)->direita)) ||
               pontoRetangulo(autonomo->posicaoX+largura,autonomo->posicaoY,aut->animacaoAtiva,aut->posicaoX,aut->posicaoY,(aut->tipo==INIMIGO_ATIRADOR?((InimigoAtirador*)aut)->direita:((InimigoEscudo*)aut)->direita)) ||
               pontoRetangulo(autonomo->posicaoX,autonomo->posicaoY+altura,aut->animacaoAtiva,aut->posicaoX,aut->posicaoY,(aut->tipo==INIMIGO_ATIRADOR?((InimigoAtirador*)aut)->direita:((InimigoEscudo*)aut)->direita)) ||
               pontoRetangulo(autonomo->posicaoX+largura,autonomo->posicaoY+altura,aut->animacaoAtiva,aut->posicaoX,aut->posicaoY,(aut->tipo==INIMIGO_ATIRADOR?((InimigoAtirador*)aut)->direita:((InimigoEscudo*)aut)->direita)))){
                 this->inserirAutonomo((Autonomos*)new ColisaoBomba(autonomo->posicaoX,autonomo->posicaoY,((BombaPrincipal*)autonomo)->colisBomba));
                 switch(aut->tipo){
                     case INIMIGO_ATIRADOR:
                         delete(((InimigoAtirador*)aut)->morrendo);
                         ((InimigoAtirador*)aut)->morrendo = new AnimacaoRotina(35,1,inimigosStagio.incinerado,0,-22);
                         ((InimigoAtirador*)aut)->morreu = true;
                         break;
                     case INIMIGO_ESCUDO:
                         delete(((InimigoEscudo*)aut)->morrendo);
                         ((InimigoEscudo*)aut)->morrendo = new AnimacaoRotina(35,1,inimigosStagio.incinerado,0,-20);
                         ((InimigoEscudo*)aut)->morreu = true;
                         ((InimigoEscudo*)aut)->estado = escudo_morto;
                         break;
                 }
                 return true;
            }
        }
        return false;
    }
    void moverElementos(){
        this->marcador++;
        
        int k=0;
        while(ponteirosArrays && ligaDebug && k< this->quantGrades){
			if(!travaR && key[KEY_R]){
			    travaR = true;
				ponteirosArrays = !ponteirosArrays;
			}
            textprintf(screen, font, 0, 80, 63519, "O valor de pontBA e quantBA eh: %d  %d",this->grade[k].pontBA,this->grade[k].quantBA);
            textprintf(screen, font, 0, 90, 63519, "O valor de pontIni e quantIni eh: %d  %d",this->grade[k].pontIni,this->grade[k].quantIni);
            textprintf(screen, font, 0, 100, 63519, "O valor de pontAut e quantAut eh: %d  %d",this->grade[k].pontAut,this->grade[k].quantAut);
            textprintf(screen, font, 0, 110, 63519, "O valor de princIsHere eh: %d",this->grade[k].princIsHere);
            rest(30);
            k++;
        }
        
       //MOVIMENTO DAS BALAS
        Bala* aux1;
       //MOVIMENTO DOS AUTONOMOS
        Autonomos* aux2;    
       //MOVE AS BALAS DOS INIMIGOS
        for(i = this->quantGrades; i >= 0; i--){
            if(i>((bfCenario->posReltX-100)/this->larguraGrade) && i<((bfCenario->posReltX+100+MAX_X)/this->larguraGrade)){      
                this->grade[i].resetIni();
                while((aux1 = this->grade[i].pegarProxBalIni()) != NULL){
                    if(aux1->marcador!=this->marcador){
                        if(aux1->mover()){
                           this->inserirAutonomo((Autonomos*)new ColisaoBA(aux1->posicaoX,aux1->posicaoY,aux1->colisBA));                   
                           this->grade[i].removeEstaBalIni();
                           delete(aux1);
                        }
                        else if((aux1->posicaoX/larguraGrade)!= i){
                            this->grade[i].removeEstaBalIni();
                            aux1->marcador = this->marcador;
                            if((aux1->posicaoY<0)||(aux1->posicaoY>MAX_Y)){
                                delete(aux1);
                            }else
                                this->grade[aux1->posicaoX/larguraGrade].inserirBalaInimigo(aux1);                            
                        }
                    }                
                }                
            }
            else if(i>((bfCenario->posReltX-150)/this->larguraGrade) || i<((bfCenario->posReltX+150)/this->larguraGrade)){
            this->grade[i].esvaziarBalIni();            
            }
        }
       //PRIMEIRO IMPRIME OS AUTONOMOS
       bool aDeletar;
       int salvaPonteiro;
       for(i = this->quantGrades; i >= 0; i--){
          if(i>((bfCenario->posReltX-100)/this->larguraGrade) && i<((bfCenario->posReltX+100+MAX_X)/this->larguraGrade)){      
                this->grade[i].resetAut();
                while((aux2 = this->grade[i].pegarProxAut()) != NULL){               
                    if(aux2->marcador!=this->marcador){
                        aux2->marcador = this->marcador;                                    
                        bool temp;
                        aDeletar = false;
                        if(temp = aux2->play()){     
                            switch(aux2->tipo){
                                case COLISAO_BALA:
                                    aDeletar = true;
                                    break;
                                case COLISAO_BOMBA:
                                    aDeletar = true;
                                    break;
                                case CAMINHAO:
                                    break;
                                case REFEM:
                                    break;
                                case PASSARINHO:
                                    break;    
                                case BOMBA_PRINCIPAL:
                                    //****************************************
                                    play_sample(som_granada, 150, 128, 1000, 0);
                                    //****************************************
                                    this->inserirAutonomo((Autonomos*)new ColisaoBomba(aux2->posicaoX,aux2->posicaoY,((BombaPrincipal*)aux2)->colisBomba));                   
                                    aDeletar = true;
                                    break;
                                case INIMIGO_ATIRADOR:
                                    if(!((InimigoAtirador*)aux2)->morreu) {
                                        //****************************************
                                        play_sample(this->som_tiro_inimigo, 150, 128, 1000, 0);
                                        //****************************************
                                        this->inserirBalIni(new Bala((!((InimigoAtirador*)aux2)->direita?aux2->posicaoX+18:aux2->posicaoX+75),aux2->posicaoY+25,(!((InimigoAtirador*)aux2)->direita?-7:7),0,this->inimigosStagio.figuraBala,2,this->inimigosStagio.figuraColBala,cenario));
                                        }
                                        break;
                                case INIMIGO_ESCUDO:
                                    if(!((InimigoEscudo*)aux2)->morreu) {
                                    //****************************************
                                    play_sample(escudo, 150, 128, 1000, 0);
                                    //****************************************
                                        this->inserirBalIni(new Bala((((InimigoEscudo*)aux2)->direita?aux2->posicaoX+18:aux2->posicaoX+58),aux2->posicaoY+10,(((InimigoEscudo*)aux2)->direita?-9:9),0,this->inimigosStagio.figuraBala,2,this->inimigosStagio.figuraColBala,cenario));
                                        }
                                    break;
                            }
                        }
                        switch(aux2->tipo){
                            case INIMIGO_ATIRADOR:
                                if(temp && ((InimigoAtirador*)aux2)->morreu){
                                    aDeletar = true;
                                    break;
                                }
                                if(foiAlvejado(aux2,((InimigoAtirador*)aux2)->direita,i)){
                                    ((InimigoAtirador*)aux2)->morreu = true;
                                }break;
                            case INIMIGO_ESCUDO:
                                if(temp && ((InimigoEscudo*)aux2)->morreu){
                                    aDeletar = true;
                                    break;
                                }
                                if(foiAlvejado(aux2,((InimigoEscudo*)aux2)->direita,i))
                                    ((InimigoEscudo*)aux2)->morreu = true;
                                break;
                            case BOMBA_PRINCIPAL:
                                salvaPonteiro = this->grade[i].pontAut;
                                if(colisRetanObjeto(aux2,18,18,i)){
                                    aDeletar = true;                                    
                                }
                                this->grade[i].pontAut = salvaPonteiro;
                                break;                            
                        }
                        if(aDeletar){
                            this->grade[i].removeEsteAut();
                            delete(aux2);
                        }else if((aux2->posicaoX/larguraGrade)!= i){
                            this->grade[i].removeEsteAut();
                            if((aux2->posicaoY<0)||(aux2->posicaoY>MAX_Y)){
                                delete(aux2);
                            }else
                                this->grade[aux2->posicaoX/larguraGrade].inserirAutonomo(aux2);                            
                        }
                    }                    
                }                                
            }            
        }
        //DEPOIS MOVE E IMPRIME AS BALAS DOS AMIGOS
        for(i = this->quantGrades; i >= 0; i--){
            if(i>((bfCenario->posReltX-100)/this->larguraGrade) && i<((bfCenario->posReltX+100+MAX_X)/this->larguraGrade)){      
                this->grade[i].resetBA();
                while((aux1 = this->grade[i].pegarProxBA()) != NULL){
                    if(aux1->marcador!=this->marcador){
                        if(aux1->imprimirBala() && aux1->mover()){
                           this->inserirAutonomo((Autonomos*)new ColisaoBA(aux1->posicaoX,aux1->posicaoY,aux1->colisBA));                   
                           this->grade[i].removeEstaBA();
                           delete(aux1);
                        }
                        else if((aux1->posicaoX/larguraGrade)!= i){
                            this->grade[i].removeEstaBA();
                            aux1->marcador = this->marcador;
                            if((aux1->posicaoY<0)||(aux1->posicaoY>MAX_Y)){
                                delete(aux1);
                            }else
                                this->grade[aux1->posicaoX/larguraGrade].inserirBalaAmigo(aux1);                            
                        }
                    }                
                }                
            }
            else if(i>((bfCenario->posReltX-150)/this->larguraGrade) || i<((bfCenario->posReltX+150)/this->larguraGrade)){
            this->grade[i].esvaziarBA();
            }
        }
        //DEPOIS IMPRIME AS BALAS DOS INIMIGOS        
        for(i = this->quantGrades; i >= 0; i--){
            if(i>((bfCenario->posReltX-100)/this->larguraGrade) && i<((bfCenario->posReltX+100+MAX_X)/this->larguraGrade)){      
                this->grade[i].resetIni();
                while((aux1 = this->grade[i].pegarProxBalIni()) != NULL){
                    aux1->imprimirBala();
                }                
            }
        }
    }
}*g_r_a_d_e;
#endif
