#ifndef MOVER
    #define MOVER
#include "cenario.h"
enum travaPulo{noChao,estagio1,aberto};

class Mover{
public:
	int i;
    int quantAMover;
    int altura;
    int largura;
    int descontoEsq;
    bool *isPulando;
    int velQueda;
    BITMAP *restricoesMapa;
    enum travaPulo travaPul;
        
    Mover(Cenario *cenario,int quantAMover,int altura,int descontoEsq,int largura, bool *pulando){
        this->restricoesMapa = cenario->cenario_restricoes;   
        this->quantAMover = quantAMover;
        this->altura = altura-1;
        this->largura = largura-1;
        this->descontoEsq = descontoEsq;
        this->isPulando = pulando; 
        this->velQueda = 0;
        this->travaPul = noChao;
		this->i = 0;
    }
    
    void setVelocidade(int vel){
       this->quantAMover = vel;
    }
    
    void pular(int *posX,int *posY, int vel){
        if(!*(this->isPulando)){
            *(this->isPulando) = true;
            this->velQueda = vel;
            this->travaPul = noChao;         
            pulando(posX,posY);            
        }
    }
    bool pulando(int *posX, int *posY){
        int cor;
        if(!*(this->isPulando))
            return false;
            
        switch(travaPul){
            case aberto:
                this->travaPul = aberto;
                break;
            case estagio1:
                this->travaPul = aberto;
                return true;                
            default:
                this->travaPul = estagio1;
                return true;                
        }
        
        *posX += this->descontoEsq;  //correcao para especificar regiao de colisao
        
        if(this->velQueda >= 0){
            if(((cor=getpixel(this->restricoesMapa,*posX,*posY+this->altura+this->velQueda))==PIXEL_TRANSP || cor==-1)&&(
               (cor=getpixel(this->restricoesMapa,*posX+this->largura,*posY+this->altura+this->velQueda))==PIXEL_TRANSP || cor==-1)){
                *posY += this->velQueda;
                this->velQueda += 1;
            }else{
                if(getpixel(this->restricoesMapa,*posX+(this->largura)/2,*posY+this->altura+26)==PIXEL_RAMPA){
                    for(i=25;i>0;i--){
                        if(getpixel(this->restricoesMapa,*posX+(this->largura)/2,*posY+this->altura+i)==PIXEL_TRANSP){
                           *posY += i;
                           break;
                        }                                        
                    }
                }else{
                    for(i=this->velQueda;i>0;i--){
                        if(((cor=getpixel(this->restricoesMapa,*posX,*posY+this->altura+i))==PIXEL_TRANSP || cor==-1)&&(
                           (cor=getpixel(this->restricoesMapa,*posX+this->largura,*posY+this->altura+i))==PIXEL_TRANSP || cor==-1)){
                            *posY += i;
                            break;
                        }
                    }                    
                }
                *(this->isPulando) = false;
                this->velQueda = 0;
            }
        
        }else{
            if(((cor=getpixel(this->restricoesMapa,*posX,*posY+this->velQueda))==PIXEL_TRANSP || cor==PIXEL_RAMPA)&&(
               (cor=getpixel(this->restricoesMapa,*posX+this->largura,*posY+this->velQueda))==PIXEL_TRANSP || cor==PIXEL_RAMPA)){
                *posY += this->velQueda;
                this->velQueda += 1;
            }else{
                for(i=this->velQueda;i<0;i++){
                    if(((cor=getpixel(this->restricoesMapa,*posX,*posY+i))==PIXEL_TRANSP || cor==PIXEL_RAMPA)&&(
               (cor=getpixel(this->restricoesMapa,*posX+this->largura,*posY+i))==PIXEL_TRANSP || cor==PIXEL_RAMPA)){
                        *posY += i;
                        break;
                    }
                }
                this->velQueda = 0;
            }
        }
        *posX -= this->descontoEsq;  //finalizando a correcao para regiao de colisao
        
        return true;
    }
    void colisFrontDir(int *posX, int *posY){
        if(getpixel(this->restricoesMapa,*posX+this->largura+this->quantAMover,*posY)==PIXEL_TRANSP &&
               getpixel(this->restricoesMapa,*posX+this->largura+this->quantAMover,*posY+this->altura)==PIXEL_TRANSP){
                *posX += this->quantAMover;
        }else{
            for(i=this->quantAMover;i>0;i--){
                if(getpixel(this->restricoesMapa,*posX+this->largura+i,*posY)==PIXEL_TRANSP &&
                getpixel(this->restricoesMapa,*posX+this->largura+i,*posY+this->altura)==PIXEL_TRANSP){
                    *posX += i;
                     break;
                }
            }
        }
    }
    void moverRampDir(int *posX,int *posY){        
        bool aux;
        switch(getpixel(this->restricoesMapa,*posX+(this->largura)/2+this->quantAMover,*posY+this->altura)){
            case PIXEL_RAMPA:
                for(i=0;i<30;i++){
                    if(getpixel(this->restricoesMapa,*posX+(this->largura)/2+this->quantAMover,*posY+this->altura-i)==PIXEL_TRANSP){
                        *posX += this->quantAMover;
                        *posY -= i;
                        break;
                    }
                }
                break;
            case PIXEL_TRANSP:
                for(i=0;i<30;i++){
                    if(aux=(getpixel(this->restricoesMapa,*posX+(this->largura)/2+this->quantAMover,*posY+this->altura+i)!=PIXEL_TRANSP)){
                        *posX += this->quantAMover;
                        *posY += i - 1;
                        break;
                    }
                }
                if(!aux)
                    *posX += this->quantAMover;
                break;
            default:
                *posX += this->quantAMover;
                break;
        }
    }
    void moverDireita(int *posX, int *posY){
    *posX += this->descontoEsq;  //correcao para especificar regiao de colisao
    
        if(!*(this->isPulando)){
            switch(getpixel(this->restricoesMapa,*posX+(this->largura)/2,*posY+this->altura+1)){
                case PIXEL_P_HORZ:                    
                    *posX += this->quantAMover;
                    break;
                case PIXEL_P_PARE:                                 
                    colisFrontDir(posX,posY);
                    break;
                case PIXEL_RAMPA:
                    moverRampDir(posX,posY);
                    break;
                default:
                    if(getpixel(this->restricoesMapa,*posX+this->quantAMover,*posY+this->altura+1)==PIXEL_TRANSP &&
                       getpixel(this->restricoesMapa,*posX+this->largura+this->quantAMover,*posY+this->altura+1)==PIXEL_TRANSP){
                        *(this->isPulando) = true;
                    }
                    *posX += this->quantAMover;
            }
        }else
            colisFrontDir(posX,posY);
            
        *posX -= this->descontoEsq;  //finalizando a correcao para regiao de colisao
    }
    void colisFrontEsq(int *posX, int *posY){
        if(getpixel(this->restricoesMapa,*posX-this->quantAMover,*posY)==PIXEL_TRANSP &&
            getpixel(this->restricoesMapa,*posX-this->quantAMover,*posY+this->altura)==PIXEL_TRANSP){
            *posX -= this->quantAMover;
        }else{
            for(i=this->quantAMover;i>0;i--){
                if(getpixel(this->restricoesMapa,*posX-i,*posY)==PIXEL_TRANSP &&
                   getpixel(this->restricoesMapa,*posX-i,*posY+this->altura)==PIXEL_TRANSP){
                     *posX -= i;
                     break;
                }
            }
        }
    }
    void moverRampEsq(int *posX,int *posY){
        bool aux;
        switch(getpixel(this->restricoesMapa,*posX+(this->largura)/2-this->quantAMover,*posY+this->altura)){
            case PIXEL_RAMPA:
                for(i=0;i<30;i++){
                    if(getpixel(this->restricoesMapa,*posX+(this->largura)/2-this->quantAMover,*posY+this->altura-i)==PIXEL_TRANSP){
                        *posX -= this->quantAMover;
                        *posY -= i;
                        break;
                    }
                }
                break;
            case PIXEL_TRANSP:
                for(i=0;i<30;i++){
                    if(aux=(getpixel(this->restricoesMapa,*posX+(this->largura)/2-this->quantAMover,*posY+this->altura+i)!=PIXEL_TRANSP)){
                        *posX -= this->quantAMover;
                        *posY += i - 1;
                        break;
                    }
                }
                if(!aux)
                    *posX -= this->quantAMover;
                break;
            default:
                *posX -= this->quantAMover;
                break;
        }
    }
    void moverEsquerda(int *posX, int *posY){
        *posX += this->descontoEsq;  //correcao para especificar regiao de colisao
        
        if(!*(this->isPulando)){
            switch(getpixel(this->restricoesMapa,*posX+(this->largura)/2,*posY+this->altura+1)){
                case PIXEL_P_HORZ:
                    *posX -= this->quantAMover;
                    break;            
                case PIXEL_P_PARE:                                 
                     colisFrontEsq(posX,posY);
                    break;
                case PIXEL_RAMPA:
                    moverRampEsq(posX,posY);
                    break;
                default:
                    if(getpixel(this->restricoesMapa,*posX-this->quantAMover,*posY+this->altura+1)==PIXEL_TRANSP &&
                       getpixel(this->restricoesMapa,*posX+this->largura-this->quantAMover,*posY+this->altura+1)==PIXEL_TRANSP)
                         *(this->isPulando) = true;
                     *posX -= this->quantAMover;
                     break;
            }
        }else
            colisFrontEsq(posX,posY);
            
        *posX -= this->descontoEsq;  //finalizando a correcao para regiao de colisao
    }
};
#endif
