#ifndef PRINCIPAL
    #define PRINCIPAL

#include "animacao.h"
#include "LoaderImages.h"
#include "mover.h"
#include "cenario.h"
#ifndef ALLEGRO
    #define ALLEGRO
    #include <allegro.h>
#endif
#ifndef SOUNDS
    #define SOUNDS
    #include "sounds.h"
#endif
#include "grade.h"
#include "colisao.h"
#include "Life.h"

enum estados_animacao {PARADO=0 , ANDANDO=1 , PULANDO=2 , ATIRANDO=4 , ABAIXADO=8 , PARA_CIMA=16, JOGANDO_BOMBA=32};
enum estados_parado {SELECT,NORMAL,BEBAGUA,DORMINDO};

class Principal{
public:
    SAMPLE *som_tiro;
    SAMPLE *som_grito_morte;
	SAMPLE *som_complete;
	SAMPLE *som_vibrando;
    bool travaPulo;
    bool travaPrincipal;
    bool perdeLifeDir;
    Life *life;
    
    Grade *grade;
    AnimacaoRotina2 *andar;
    AnimacaoRotina *andarAtirando;
    AnimacaoAndar *andaOlhaCima;
    AnimacaoPular *pular;
    AnimacaoRotina *atirarParado;
    AnimacaoRotina *beboAgua;
    AnimacaoRotina *dormir;
    AnimacaoRotina *parado;
    AnimacaoRotina2 *abaixado;
    AnimacaoRotina *andarAbaix;
    AnimacaoRotina *atirarAbaix;
    AnimacaoRotina *jogarBombaAbaix;
    AnimacaoRotina *atirarPBaixo;
    AnimacaoRotina *atirarPulando;
    AnimacaoRotina *perdeLife;
    AnimacaoRotina2 *mirandoPBaixo;
    AnimacaoRotina2 *olhandoCima;
    AnimacaoRotina *atirandoPCima;
    AnimacaoRotina *andandoAtirandoPCima;
    AnimacaoRotina *pulandoBomba;
    AnimacaoRotina *paradoJogandoBomba;
    AnimacaoRotina *andandoJogandoBomba;
    AnimacaoRotina *morrendo;
    AnimacaoRotina *comemorando;
    AnimacaoRotina *esfaquearAbaixado;
    ParFigura *figuraBA;
    ParFigura *figuraBVertical;
    ParFigura *figuraColBA;
    ParFigura *bomba1;
    ParFigura *bomba2;
    ParFigura *colisBomba;
    Mover *movimento;
    Cenario *cenario;
    bool pulando;
    bool direita;
    int posAtaqX;
    int posAtaqY;    
    int posGrade;
    enum estados_animacao estados;
    enum estados_parado estadosParado;
    int estadoAtual;
    int estadoAnterior;
    int travaColisao;
    bool travaTiro;  //usando para evitar efeito metralhadora
    //controles de tiro
    bool isAtiranAbaix;
    bool isAtiranPBaixo;
    bool isAtiranParado;
    bool isAtiranAndando;
    bool isAtiranPulando;
    bool isJogandoBomba;
    bool atiranPCimaPar;
    bool andanAtiranPCima;
    bool isJogamdoBombaPulando;
    bool isJogandoBombaParado;
    bool isJogandoBombaAndando;
    bool isEsfaqueandoAbaixado;
    bool morreu;
    bool ressureicao;
   // bool venceu;
    
    Animacao *animacaoAtiva;
            
    Principal(int posAtaqX,int posAtaqY,Animacoes *animacoes,Cenario *cenario,Grade *grade){
        this->som_tiro = load_sample(tiro);
		this->som_complete = load_sample(complete);
		this->som_vibrando = load_sample(vibrando);
        this->som_grito_morte = load_sample(grito_morte);
        this->travaPulo = false;
        this->travaPrincipal = false;
        this->life = new Life();
        this->grade = grade;
        this->movimento = new Mover(cenario,5/*lembrar de fazer variavel*/
                          ,48,12,14
                          ,&(this->pulando));
        this->cenario = cenario;
        this->andar = animacoes->SLUG_ANDANDO_PISTOLA;
        this->andarAtirando = animacoes->SLUG_ANDAR_ATIRANDO;
        this->andaOlhaCima = animacoes->SLUG_ANDANDO_OLHANDO_P_CIMA;
        this->pular = animacoes->SLUG_PULANDO;
        this->atirarPulando = animacoes->SLUG_ATIRANDO_PULANDO;
        this->atirarParado = animacoes->SLUG_ATIRANDO_PISTOLA;
        this->beboAgua = animacoes->SLUG_BEBENDO_AGUA;
        this->dormir = animacoes->SLUG_DORMINDO;
        this->parado = animacoes->SLUG_PARADO;
        this->abaixado = animacoes->SLUG_ABAIXADO;
        this->andarAbaix = animacoes->SLUG_ANDANDO_ABAIXADO;
        this->atirarAbaix = animacoes->SLUG_ATIRANDO_ABAIXADO;
        this->jogarBombaAbaix = animacoes->SLUG_JOGANDO_BOMBA;
        this->atirarPBaixo = animacoes->SLUG_ATIRANDO_P_BAIXO;
        this->mirandoPBaixo = animacoes->SLUG_MIRNADO_P_BAIXO;
        this->olhandoCima = animacoes->SLUG_OLHANDO_P_CIMA;
        this->perdeLife = animacoes->PERDER_LIFE;
        this->atirandoPCima = animacoes->ATIRANDO_P_CIMA;
        this->andandoAtirandoPCima = animacoes->ANDANDO_ATIRANDO_P_CIMA;
        this->pulandoBomba = animacoes->PULANDO_JOGANDO_BOMBA;
        this->paradoJogandoBomba = animacoes->PARADO_JOGANDO_BOMBA;
        this->andandoJogandoBomba = animacoes->ANDANDO_JOGANDO_BOMBA;
        this->morrendo = animacoes->MORRENDO;
        this->comemorando = animacoes->COMEMORANDO;
        this->esfaquearAbaixado = animacoes->ESFAQUEAR_ABAIXADO;
        this->pulando = true;
        this->direita = true;
        this->posAtaqX = posAtaqX;
        this->posAtaqY = posAtaqY;
        this->posGrade = 0;
        this->estados = PARADO;
        this->estadosParado = SELECT;
        this->estadoAtual = 0;
        this->estadoAnterior = 0;
        this->travaColisao = 0;
        this->travaTiro = false;
        this->isAtiranAbaix = false;
        this->isAtiranPBaixo = false;
        this->isAtiranParado = false;
        this->isAtiranAndando = false;
        this->isAtiranPulando = false;
        this->isJogandoBomba = false;
        this->atiranPCimaPar = false;
        this->andanAtiranPCima = false;
        this->isJogamdoBombaPulando = false;
        this->isJogandoBombaParado = false;
        this->isJogandoBombaAndando = false;
        this->isEsfaqueandoAbaixado = false;
        this->morreu = false;
        this->ressureicao = false;
      //  this->venceu = false;
        this->figuraBA = new ParFigura("images\\Bala.bmp");
        this->figuraBVertical = new ParFigura("images\\BalaVertical.bmp");
        this->figuraColBA = new ParFigura("images\\explosaoBala.bmp");
        this->bomba1 = new ParFigura("images\\bomba1.bmp");
        this->bomba2 = new ParFigura("images\\bomba2.bmp");
        this->colisBomba = new ParFigura("images\\explosao.bmp");
    }
    ~Principal(){ 
        delete(this->life);
        delete(this->movimento);
        delete(this->figuraBA);
        delete(this->figuraBVertical);
        delete(this->figuraColBA);
        delete(this->bomba1);
        delete(this->bomba2);      
        delete(this->colisBomba);
    }
    void moverPrincipal(){
        
        if(!this->travaPrincipal){ 
            if(key[KEY_SPACE] && !this->travaPulo){
                this->movimento->pular(&posX,&posY,-12);    
                this->travaPulo = true;
            }
            if(!key[KEY_SPACE])
                this->travaPulo = false;
           
        }
        this->movimento->pulando(&posX,&posY);//funcao precisa ser chamada sempre para analisar se est no ar e fazer correcoes se necessario;       

        if(!this->travaPrincipal){              
            if(key[KEY_LEFT] && !key[KEY_RIGHT])
                this->movimento->moverEsquerda(&posX,&posY);
            else if(key[KEY_RIGHT] && !key[KEY_LEFT])
                this->movimento->moverDireita(&posX,&posY);
        }
    }
    void auxParado(){
        switch(this->estadosParado){
            case SELECT:
                switch(rand()%30){ 
                    case 7:
                        this->estadosParado = BEBAGUA;
                        this->beboAgua->play(posX,posY,false,this->direita);
                        this->animacaoAtiva = (Animacao*)this->beboAgua;
                        break;
                    case 11:
                        this->estadosParado = DORMINDO;
                        this->dormir->play(posX,posY,false,this->direita);
                        this->animacaoAtiva = (Animacao*)this->dormir;
                        break;
                    default:
                        this->estadosParado = NORMAL;
                        this->parado->play(posX,posY,false,this->direita);        
                        this->animacaoAtiva = (Animacao*)this->parado;
                        break;
                }
                break;
            case BEBAGUA:
                if(this->beboAgua->play(posX,posY,true,this->direita))
                    this->estadosParado = NORMAL;            
                this->animacaoAtiva = (Animacao*)this->beboAgua;
                break;
            case DORMINDO:
                if(this->dormir->play(posX,posY,true,this->direita))
                    this->estadosParado = NORMAL;        
                this->animacaoAtiva = (Animacao*)this->dormir;    
                break;            
            case NORMAL:
                if(this->parado->play(posX,posY,true,this->direita))
                    this->estadosParado = SELECT; 
                this->animacaoAtiva = (Animacao*)this->parado;
                break;        
        }
    }
    void animar(){ 
        BombaPrincipal *aut;
        if(this->life->lifeIsEmpty()){
           MORREU = true;
           return;
        }
        this->life->printLife(buffer,bfCenario->posReltX+25,15);
            
        if(this->ressureicao){
            if(!this->life->lifeIsEmpty()){
                posY = 50;
                this->pulando = true;
                this->life->reloadLife();
                this->ressureicao = false;
                this->travaPrincipal = false;                
            }else{
                MORREU = true;                
            }
            return;
        }
        
        if(this->travaPrincipal && !this->life->isEmpty()){
            this->perderLife(this->perdeLifeDir);            
            return;
        }
        if(this->life->isEmpty()){
            this->morrer();
            return;
        }
        if(posY > MAX_Y)
            MORREU = true;
        
        if(posX > (cenario->cenario_fundo->w - 100)){
            this->comemorar();
            return;
        }            
             
        this->estadoAtual = 0;
        
        if(key[KEY_LEFT] && !key[KEY_RIGHT]){    //esquerda   (ISOLA_SE A TECLA OPOSTA)
            this->direita = false;
            this->estadoAtual |= ANDANDO;
        }
        else if(key[KEY_RIGHT] && !key[KEY_LEFT]){//direita    (ISOLA_SE A TECLA OPOSTA)
            this->direita = true;
            this->estadoAtual |= ANDANDO;
        }
        if(key[KEY_A] && !key[KEY_D] && !this->travaTiro){        //atirar
            this->estadoAtual |= ATIRANDO;
            this->travaTiro = true;
        }else if(key[KEY_D] && !key[KEY_A] && !this->travaTiro){        //jogar bomba
            this->estadoAtual |= JOGANDO_BOMBA;
            this->travaTiro = true;
        }
        if(!key[KEY_A]&&!key[KEY_D])                            //trava o tiro para que nao aconteca metralhadora
            this->travaTiro = false;
            
        if(this->pulando)                         //pulando
            this->estadoAtual |= PULANDO;
        
        if(key[KEY_UP] && !key[KEY_DOWN])         //pra cima     (ISOLA_SE A TECLA OPOSTA)
            this->estadoAtual |= PARA_CIMA;
        else if(key[KEY_DOWN] && !key[KEY_UP])    //pra baixo    (ISOLA_SE A TECLA OPOSTA)
            this->estadoAtual |= ABAIXADO;
        
        if((this->estadoAnterior==12 || this->estadoAnterior==8)&& this->estadoAtual!=8){  //elimina o problema de derrepente abaixar e atirar*
            this->isAtiranAbaix = false;
            this->isEsfaqueandoAbaixado = false;
        }            
        if((this->estadoAnterior==14 || this->estadoAnterior==10)&& this->estadoAtual!=10)  //elimina o problema de derrepente pular mirando pra baixo e sozinho atirar*
            this->isAtiranPBaixo = false;
        
        if((this->estadoAnterior==4 || this->estadoAnterior==0)&& this->estadoAtual!=0)  //elimina o problema de derrepente parar e sozinho atirar*
            this->isAtiranParado = false;
            
        if((this->estadoAnterior==5 || this->estadoAnterior==1)&& this->estadoAtual!=1)  //elimina o problema de derrepente andar e sozinho atirar*
            this->isAtiranAndando = false;

        if((this->estadoAnterior==6 || this->estadoAnterior==2)&& this->estadoAtual!=2)  //elimina o problema de derrepente andar e sozinho atirar*
            this->isAtiranPulando = false;
        
        if((this->estadoAnterior==40 || this->estadoAnterior==8)&& this->estadoAtual!=8)  //elimina o problema de derrepente andar e sozinho atirar*
            this->isJogandoBomba = false;
            
        if((this->estadoAnterior==20 || this->estadoAnterior==16)&& this->estadoAtual!=16)  //elimina o problema de derrepente andar e sozinho atirar*
            this->atiranPCimaPar = false;
         
        if((this->estadoAnterior==21 || this->estadoAnterior==17)&& this->estadoAtual!=17)  //elimina o problema de derrepente andar e sozinho atirar*
            this->andanAtiranPCima = false;
                        
        if((this->estadoAnterior==34 || this->estadoAnterior==2)&& this->estadoAtual!=2)  //elimina o problema de derrepente andar e sozinho atirar*
            this->isJogamdoBombaPulando = false;
        
        if((this->estadoAnterior==32 || this->estadoAnterior==0)&& this->estadoAtual!=0)  //elimina o problema de derrepente andar e sozinho atirar*
            this->isAtiranPulando = false;
                
        if((this->estadoAnterior==33 || this->estadoAnterior==1)&& this->estadoAtual!=1)  //elimina o problema de derrepente andar e sozinho atirar*
            this->isJogandoBombaAndando = false;
        
        switch(this->estadoAtual){
            case 0:            //parado
                parado_:
                if(this->isAtiranParado){
                    this->isAtiranParado = !this->atirarParado->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);
                    this->animacaoAtiva = (Animacao*)this->atirarParado;
                }else if(this->isAtiranPulando){
                    this->isAtiranPulando = !this->paradoJogandoBomba->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);
                    this->animacaoAtiva = (Animacao*)this->paradoJogandoBomba;
                }else
                    auxParado();
                break;
            case 1:            //andando normal sem atirar e sem pular
                andando_:
                if(this->isAtiranAndando){
                    this->isAtiranAndando = !this->andarAtirando->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);
                    this->animacaoAtiva = (Animacao*)this->andarAtirando;
                }else if(this->isJogandoBombaAndando){
                    this->isJogandoBombaAndando = !this->andandoJogandoBomba->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);
                    this->animacaoAtiva = (Animacao*)this->andandoJogandoBomba;
                }else{
                    this->andar->play(posX,posY,4,this->estadoAtual==this->estadoAnterior,this->direita);
                    this->animacaoAtiva = (Animacao*)this->andar;
                }
                break;
            case 2:            //pulando reto sem atirar
                pulando_reto:
                if(this->isAtiranPulando){
                    this->isAtiranPulando = !this->atirarPulando->play(posX,posY,true,this->direita);
                    this->animacaoAtiva = (Animacao*)this->atirarPulando;
                }else if(this->isJogamdoBombaPulando ){
                    this->isJogamdoBombaPulando = !this->pulandoBomba->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);
                    this->animacaoAtiva = (Animacao*)this->pulandoBomba;
                }else{
                    this->pular->pular(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);
                    this->animacaoAtiva = (Animacao*)this->pular;
                }
                break;
            case 3:            //pulando pra frente sem atirar
                goto pulando_reto;
            case 4:            //atirando parado sem pular
                //******************************************
                play_sample(som_tiro, 255, 128, 1000, 0);
                //******************************************
                this->atirarParado->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);
                this->animacaoAtiva = (Animacao*)this->atirarParado;
                this->isAtiranParado = true;
                this->grade->inserirBA(new Bala((this->direita?posX+35:posX-7),posY+19,(this->direita? 10 : -10),0,this->figuraBA,1,this->figuraColBA,this->cenario));
                break;                
            case 5:            //andando atirando sem pular
                //******************************************
                play_sample(som_tiro, 150, 128, 1000, 0);
                //******************************************
                this->animacaoAtiva = (Animacao*)this->andarAtirando;
                this->andarAtirando->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);
                this->isAtiranAndando = true;
                this->grade->inserirBA(new Bala((this->direita?posX+35:posX-7),posY+15,(this->direita? 10 : -10),0,this->figuraBA,1,this->figuraColBA,this->cenario));
                break;
            case 6:            //atirando pulando reto
                atirando_pulando:
                //******************************************
                play_sample(som_tiro, 150, 128, 1000, 0);
                //******************************************
                this->atirarPulando->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);                    
                this->animacaoAtiva = (Animacao*)this->atirarPulando;                
                this->isAtiranPulando = true;
                this->grade->inserirBA(new Bala((this->direita?posX+40:posX-12),posY+8,(this->direita? 10 : -10),0,this->figuraBA,1,this->figuraColBA,this->cenario));
                break;
            case 7:            //pulando pra frente e atirando
                goto atirando_pulando;
            case 8:            //abaixado e faz mais nada
                if(this->isAtiranAbaix){
                    this->isAtiranAbaix = !this->atirarAbaix->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);
                    this->animacaoAtiva = (Animacao*)this->atirarAbaix;
                }else if(this->isJogandoBomba){
                    this->isJogandoBomba = !this->jogarBombaAbaix->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);
                    this->animacaoAtiva = (Animacao*)this->jogarBombaAbaix;
                }else if(this->isEsfaqueandoAbaixado){
                    this->isEsfaqueandoAbaixado = !this->esfaquearAbaixado->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);
                    this->animacaoAtiva = (Animacao*)this->esfaquearAbaixado;
                }else if(this->estadoAnterior==9 || this->estadoAnterior==40){   //confere o estado anterior pra nao reiniciar se ele j estava abaixado e em outro estado
                    this->abaixado->play(posX,posY,3,this->estadoAtual==this->estadoAnterior,this->direita);                    
                    this->animacaoAtiva = (Animacao*)this->abaixado;
                }else{
                    this->abaixado->play(posX,posY,0,this->estadoAtual==this->estadoAnterior,this->direita);
                    this->animacaoAtiva = (Animacao*)this->abaixado;
                }
                break;
            case 9:            //andando abaixado
                andando_abaixado:          
                this->andarAbaix->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);
                this->animacaoAtiva = (Animacao*)this->andarAbaix;
                break;
            case 10:            //pulando mirando pra baixo
                pulando_mirando_p_baixo:
                if(this->isAtiranPBaixo){
                    this->isAtiranPBaixo = !this->atirarPBaixo->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);
                    this->animacaoAtiva = (Animacao*)this->atirarPBaixo;
                }else{
                    this->mirandoPBaixo->play(posX,posY,0,this->estadoAtual==this->estadoAnterior,this->direita);
                    this->animacaoAtiva = (Animacao*)this->mirandoPBaixo;
                }
                break;
            case 11:            //pulando pra frente olhando pra baixo(pode ser reto mesmo)
                goto pulando_mirando_p_baixo; 
                                
            case 12:            //atirando abaixado ou esfaqueando
                if(this->podeEsfaquear(true)){
                    this->esfaquearAbaixado->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);
                    this->animacaoAtiva = (Animacao*)this->esfaquearAbaixado;
                    this->isEsfaqueandoAbaixado = true;                                   
                }else{
                    //******************************************
                    play_sample(som_tiro, 150, 128, 1000, 0);
                    //******************************************
                    this->atirarAbaix->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);
                    this->animacaoAtiva = (Animacao*)this->atirarAbaix;
                    this->isAtiranAbaix = true;
                    this->grade->inserirBA(new Bala((this->direita?posX+38:posX-10),posY+28,(this->direita? 10 : -10),0,this->figuraBA,1,this->figuraColBA,this->cenario));
                }
                break;
            case 13:            //andando abaixado e atirando(NAO EXISTE, ENTAO(ANDANDO ABAIXADO))
                goto andando_abaixado;                               
            case 14:            //pulando reto e atirando pra baixo
                pulando_atirando_p_baixo:
                //******************************************
                play_sample(som_tiro, 150, 128, 1000, 0);
                //******************************************
                this->atirarPBaixo->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);
                this->animacaoAtiva = (Animacao*)this->atirarPBaixo;
                this->isAtiranPBaixo = true;
                this->grade->inserirBA(new Bala((this->direita?posX+21:posX+15),posY+35,0,10,this->figuraBVertical,1,this->figuraColBA,this->cenario));
                break;
            case 15:            //pulando pra frente e  atirando pra baixo
                goto pulando_atirando_p_baixo;
                
            case 16:            //olhando pra cima(senao apenas parado)
                olhando_p_cima:
                if(this->atiranPCimaPar){
                    this->atiranPCimaPar = !this->atirandoPCima->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);
                    this->animacaoAtiva = (Animacao*)this->atirandoPCima;
                }else if(this->estadoAnterior==17){
                    this->olhandoCima->play(posX,posY,3,this->estadoAtual==this->estadoAnterior,this->direita);
                    this->animacaoAtiva = (Animacao*)this->olhandoCima;
                }else{
                    this->olhandoCima->play(posX,posY,0,this->estadoAtual==this->estadoAnterior,this->direita);
                    this->animacaoAtiva = (Animacao*)this->olhandoCima;
                }
                                                
                break;
            case 17:            //andando e olhando pra cima(senao apenas andando)
                andando_olhando_p_cima:
                if(this->andanAtiranPCima){
                    this->andanAtiranPCima = !this->andandoAtirandoPCima->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);
                  //  this->animacaoAtiva = (Animacao*)this->andanAtiranPCima;
                }else{ 
                    this->andaOlhaCima->andar(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);
                    this->animacaoAtiva = (Animacao*)this->andaOlhaCima;
                }
                break;
            case 18:            //pulando e olhando pra cima(APENAS PULANDO NORMAL)
                goto pulando_reto;
                break;
            case 19:            //pulando pra frente e olhando pra cima(senao apenas pulando pra frente)
                goto pulando_reto;
                break;
            case 20:            //atirando pra cima
                //******************************************
                play_sample(som_tiro, 150, 128, 1000, 0);
                //******************************************
                this->atirandoPCima->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);
                this->animacaoAtiva = (Animacao*)this->atirandoPCima;
                this->atiranPCimaPar = true;
                this->grade->inserirBA(new Bala((this->direita?posX+12:posX+20),posY-28,0,-10,this->figuraBVertical,1,this->figuraColBA,this->cenario));
                break;
            case 21:            //andando e atirando pra cima
                //******************************************
                play_sample(som_tiro, 150, 128, 1000, 0);
                //******************************************
                this->andandoAtirandoPCima->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);
                this->andanAtiranPCima = true;
                this->animacaoAtiva = (Animacao*)this->andandoAtirandoPCima;
                this->grade->inserirBA(new Bala((this->direita?posX+15:posX+15),posY-28,0,-10,this->figuraBVertical,1,this->figuraColBA,this->cenario));
                break;
            case 22:            //pulando reto e atirando pra cima
                goto pulando_reto;
                break;
            case 23:            //pulando pra frente e atirando pra cima
                goto pulando_reto;
                break;
            case 32:            //parado e jogando a bomba*****
                this->paradoJogandoBomba->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);
                this->isAtiranPulando = true;  
                this->grade->inserirAutonomo((Autonomos*)new BombaPrincipal((this->direita?posX+25:posX-5),posY-10,this->direita,this->bomba1,this->bomba2,this->colisBomba));
                this->animacaoAtiva = (Animacao*)this->paradoJogandoBomba;
                break;
            case 33:            //andando e jogando a bomba*****
                this->andandoJogandoBomba->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);
                this->isJogandoBombaAndando = true;
                aut = new BombaPrincipal((this->direita?posX+25:posX-5),posY-10,this->direita,this->bomba1,this->bomba2,this->colisBomba);
                aut->movimento->quantAMover += 3;
                this->grade->inserirAutonomo((Autonomos*)aut);
                this->animacaoAtiva = (Animacao*)this->andandoJogandoBomba;
                break;
            case 34:            //pulando e jogando a bomba*****
                pulando_bomba:
                this->pulandoBomba->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);
                this->isJogamdoBombaPulando = true;
                aut = new BombaPrincipal((this->direita?posX+25:posX-5),posY-10,this->direita,this->bomba1,this->bomba2,this->colisBomba);
                if(this->estadoAtual == 35)
                    aut->movimento->quantAMover += 3;
                this->grade->inserirAutonomo((Autonomos*)aut);
                this->animacaoAtiva = (Animacao*)this->pulandoBomba;
                break;
            case 35:            //pulando pra frente e jogando a bomba*****
                goto pulando_bomba;
                break;
            case 40:            //jogando bomba abaixado
                this->jogarBombaAbaix->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);
                this->animacaoAtiva = (Animacao*)this->jogarBombaAbaix;
                this->isJogandoBomba = true;
                this->grade->inserirAutonomo((Autonomos*)new BombaPrincipal((this->direita?posX+30:posX-10),posY+10,this->direita,this->bomba1,this->bomba2,this->colisBomba));
                break;
                break;
            case 41:            //andando abaixado e jogando a bomba*****
                goto andando_abaixado;
                break;
            case 42:            //pulando mirando pra baixo e jogando a bomba*****
                goto pulando_mirando_p_baixo;
                break;
            case 43:            //pulando pra frente e mirando pra baixo e jogando a bomba*****
                goto pulando_mirando_p_baixo;
                break;
            case 48:            //jogando a bomba pra cima *****
                goto olhando_p_cima;
                break;
            case 49:            //andando e mirando pra cima e jogando a bomba*****
                goto andando_olhando_p_cima;
                break;
            case 50:            //pulando e jogando a bomba*****
                goto pulando_reto;
                break;
            case 51:            //pulando pra frente e mirando pra cima e jogando a bomba*****
                goto pulando_reto;
                break;                        
            default:         //caso especial para evitar que nao aparea nada (parado)
                goto parado_;
                break;
        }
		if(pontosCriticosDeColisoes && ligaDebug)
			podeEsfaquear(false);
       
	   if(pontosCriticosDeColisoes && ligaDebug)
	       rect(buffer,posX,posY,posX,posY,63519);
        
       if(this->estadoAtual == 13 || this->estadoAtual == 9)          //seta a velocidade de movimento                                        
           this->movimento->setVelocidade(1);
       else
           this->movimento->setVelocidade(5);
           
       this->estadoAnterior = this->estadoAtual;  //armazena o estadoAtual em estadoAnterior para calculos no proximo estado   
       
       if(this->estadoAtual != 0)                 //atualiza o estado parado
           this->estadosParado = NORMAL;
       
                 //CORRECAO DA POSICAO DO PERSONAGEM PRINCIPAL NA GRADE       
       this->grade->grade[this->posGrade].princIsHere = false;
       this->grade->grade[this->posGrade = posX/this->grade->larguraGrade].princIsHere = true;        
         
         //COLISAO DAS BALAS DO INIMIGO COM O PRINCIPAL
       if(this->travaColisao < 30)
            this->travaColisao++;
       if(this->travaColisao >= 30 && colisaoBalaRetangulo(this->animacaoAtiva)){
           this->travaPrincipal = true;
           this->travaColisao = 0;
           this->life->decrLife(1);
           //GRITOOOOOOOOOOOOOOOOOOoo********************************************************************
       }
       //MORREU = this->life->lifeIsEmpty();
    }  
    bool colisaoBalaRetangulo(Animacao* animacaoAtiva){ 
		if(imortal && ligaDebug)
			return false;

		Bala *bala;
        this->grade->grade[this->posGrade].resetIni();
        if(this->posGrade-1>=0)
			this->grade->grade[this->posGrade-1].resetIni();
        this->grade->grade[this->posGrade+1].resetIni();
        
        while((bala = this->grade->grade[this->posGrade].pegarProxBalIni()) != NULL){
            if(pontoRetangulo(bala->getPosAtqX()-4,bala->getPosAtqY(),animacaoAtiva,posX,posY,this->direita) ||
               pontoRetangulo(bala->getPosAtqX()+3,bala->getPosAtqY(),animacaoAtiva,posX,posY,this->direita) ||
               pontoRetangulo(bala->getPosAtqX(),bala->getPosAtqY()-3,animacaoAtiva,posX,posY,this->direita) ||
               pontoRetangulo(bala->getPosAtqX(),bala->getPosAtqY()+4,animacaoAtiva,posX,posY,this->direita)){
                this->grade->inserirAutonomo((Autonomos*)new ColisaoBA(bala->posicaoX,bala->posicaoY,bala->colisBA));                   
                this->grade->grade[this->posGrade].removeEstaBalIni();
                this->perdeLifeDir = (bala->velocMovX < 0);
                delete(bala);
                return true;
            }
        }
        while((this->posGrade-1>=0)&& this->posGrade>0 && (bala = this->grade->grade[this->posGrade-1].pegarProxBalIni()) != NULL){
            if(pontoRetangulo(bala->getPosAtqX()-4,bala->getPosAtqY(),animacaoAtiva,posX,posY,this->direita) ||
               pontoRetangulo(bala->getPosAtqX()+3,bala->getPosAtqY(),animacaoAtiva,posX,posY,this->direita) ||
               pontoRetangulo(bala->getPosAtqX(),bala->getPosAtqY()-3,animacaoAtiva,posX,posY,this->direita) ||
               pontoRetangulo(bala->getPosAtqX(),bala->getPosAtqY()+4,animacaoAtiva,posX,posY,this->direita)){
                this->grade->inserirAutonomo((Autonomos*)new ColisaoBA(bala->posicaoX,bala->posicaoY,bala->colisBA));                   
                this->grade->grade[this->posGrade-1].removeEstaBalIni();
                this->perdeLifeDir = (bala->velocMovX < 0);
                delete(bala);
                return true;
            }
        }
        while(this->posGrade<this->grade->quantGrades &&
             (bala = this->grade->grade[this->posGrade+1].pegarProxBalIni()) != NULL){
            if(pontoRetangulo(bala->getPosAtqX()-4,bala->getPosAtqY(),animacaoAtiva,posX,posY,this->direita) ||
               pontoRetangulo(bala->getPosAtqX()+3,bala->getPosAtqY(),animacaoAtiva,posX,posY,this->direita) ||
               pontoRetangulo(bala->getPosAtqX(),bala->getPosAtqY()-3,animacaoAtiva,posX,posY,this->direita) ||
               pontoRetangulo(bala->getPosAtqX(),bala->getPosAtqY()+4,animacaoAtiva,posX,posY,this->direita)){
                this->grade->inserirAutonomo((Autonomos*)new ColisaoBA(bala->posicaoX,bala->posicaoY,bala->colisBA));                   
                this->grade->grade[this->posGrade+1].removeEstaBalIni();
                this->perdeLifeDir = (bala->velocMovX < 0);
                delete(bala);
                return true;
            }
        }
        return false;
    } 
    void perderLife(bool direita){
        this->movimento->setVelocidade(3);
        if(!direita)
            this->movimento->moverDireita(&posX,&posY);
        else
            this->movimento->moverEsquerda(&posX,&posY);
        this->travaPrincipal = !this->perdeLife->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->direita);
     //   if(!this->travaPrincipal)
     //       posY = 50;
    } 
    void morrer(){
        this->movimento->setVelocidade(1);
        rest(10);
        if(!this->perdeLifeDir)
            this->movimento->moverDireita(&posX,&posY);
        else
            this->movimento->moverEsquerda(&posX,&posY);
        this->ressureicao = this->morrendo->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->perdeLifeDir);
        if(((Animacao*)this->morrendo)->ponteiro == 0)
           play_sample(som_grito_morte, 200, 128, 1000, 0); 
           //*********************************************************************************
    }
    void comemorar(){
        VENCEU = this->comemorando->play(posX,posY,this->estadoAtual==this->estadoAnterior,this->perdeLifeDir);
		if(stage == 3 && ((Animacao*)this->comemorando)->ponteiro == 0) {
			play_sample(som_complete, 200, 128, 1000, 0);
			play_sample(som_vibrando, 200, 128, 1000, 0);
		}
    }
    bool podeEsfaquear(bool b){
        if((posGrade-1)>=0){
            if(this->AuxPodeEsfaquear(-1,b))
                return true;
        }
       return(this->AuxPodeEsfaquear(0,b)||this->AuxPodeEsfaquear(1,b));
    }
    bool AuxPodeEsfaquear(int deslocamentoGrade,bool b){
        Autonomos* aut;
        this->grade->grade[posGrade+deslocamentoGrade].resetAut();
        if(this->direita){
            while((aut = this->grade->grade[posGrade+deslocamentoGrade].pegarProxAut()) != NULL){
                if((aut->tipo == INIMIGO_ATIRADOR || aut->tipo == INIMIGO_ESCUDO)&&(
                   pontoRetangulo(posX+34+((Animacao*)this->esfaquearAbaixado)->corrImprX,posY+0+((Animacao*)this->esfaquearAbaixado)->corrImprY,aut->animacaoAtiva,aut->posicaoX,aut->posicaoY,(aut->tipo==INIMIGO_ATIRADOR?((InimigoAtirador*)aut)->direita:((InimigoEscudo*)aut)->direita))||
                   pontoRetangulo(posX+31+((Animacao*)this->esfaquearAbaixado)->corrImprX,posY+28+((Animacao*)this->esfaquearAbaixado)->corrImprY,aut->animacaoAtiva,aut->posicaoX,aut->posicaoY,(aut->tipo==INIMIGO_ATIRADOR?((InimigoAtirador*)aut)->direita:((InimigoEscudo*)aut)->direita))||
                   pontoRetangulo(posX+52+((Animacao*)this->esfaquearAbaixado)->corrImprX,posY+19+((Animacao*)this->esfaquearAbaixado)->corrImprY,aut->animacaoAtiva,aut->posicaoX,aut->posicaoY,(aut->tipo==INIMIGO_ATIRADOR?((InimigoAtirador*)aut)->direita:((InimigoEscudo*)aut)->direita))||
                   pontoRetangulo(posX+49+((Animacao*)this->esfaquearAbaixado)->corrImprX,posY+5+((Animacao*)this->esfaquearAbaixado)->corrImprY,aut->animacaoAtiva,aut->posicaoX,aut->posicaoY,(aut->tipo==INIMIGO_ATIRADOR?((InimigoAtirador*)aut)->direita:((InimigoEscudo*)aut)->direita))
                   )){
					if(b){
						(aut->tipo == INIMIGO_ATIRADOR?((InimigoAtirador*)aut)->morreu = true:((InimigoEscudo*)aut)->morreu = true);
						if(aut->tipo == INIMIGO_ESCUDO)
							((InimigoEscudo*)aut)->estado = escudo_morto;
						return true;                 
					}
                }
            }
        }else{
            while((aut = this->grade->grade[posGrade+deslocamentoGrade].pegarProxAut()) != NULL){
                if((aut->tipo == INIMIGO_ATIRADOR || aut->tipo == INIMIGO_ESCUDO)&&(
                   pontoRetangulo(posX+20+((Animacao*)this->esfaquearAbaixado)->corrImprX,posY+0+((Animacao*)this->esfaquearAbaixado)->corrImprY,aut->animacaoAtiva,aut->posicaoX,aut->posicaoY,(aut->tipo==INIMIGO_ATIRADOR?((InimigoAtirador*)aut)->direita:((InimigoEscudo*)aut)->direita))||
                   pontoRetangulo(posX+27+((Animacao*)this->esfaquearAbaixado)->corrImprX,posY+28+((Animacao*)this->esfaquearAbaixado)->corrImprY,aut->animacaoAtiva,aut->posicaoX,aut->posicaoY,(aut->tipo==INIMIGO_ATIRADOR?((InimigoAtirador*)aut)->direita:((InimigoEscudo*)aut)->direita))||
                   pontoRetangulo(posX+5+((Animacao*)this->esfaquearAbaixado)->corrImprX,posY+19+((Animacao*)this->esfaquearAbaixado)->corrImprY,aut->animacaoAtiva,aut->posicaoX,aut->posicaoY,(aut->tipo==INIMIGO_ATIRADOR?((InimigoAtirador*)aut)->direita:((InimigoEscudo*)aut)->direita))||
                   pontoRetangulo(posX+8+((Animacao*)this->esfaquearAbaixado)->corrImprX,posY+5+((Animacao*)this->esfaquearAbaixado)->corrImprY,aut->animacaoAtiva,aut->posicaoX,aut->posicaoY,(aut->tipo==INIMIGO_ATIRADOR?((InimigoAtirador*)aut)->direita:((InimigoEscudo*)aut)->direita))
                   )){
                    if(b){
						(aut->tipo == INIMIGO_ATIRADOR?((InimigoAtirador*)aut)->morreu = true:((InimigoEscudo*)aut)->morreu = true);
						if(aut->tipo == INIMIGO_ESCUDO)
							((InimigoEscudo*)aut)->estado = escudo_morto;
						return true;                 
					}
                }
            }
        }        
        return false;
    }    
}*principal;
#endif
